<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class MemberRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('members'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        //dd(request());
        $rules=[
            'photo' => 'sometimes',
            'name'=> 'required|min:3',
            
            'email' => [
                'required',
                'email',
                Rule::unique('users')->ignore($this->member? $this->member->id : 0, 'id')
            ],
            'phone'=> [
                "required",
                "numeric",
                "digits_between:9,14",
                Rule::unique('users')->ignore($this->member? $this->member->id : 0, 'id')
            ],
        ];

        if ( !$this->member  ) {
            $rules['password'] ='required|confirmed';
        } else {
            $rules['password'] ='sometimes|confirmed';
        }
        
        
        if(request('role') == 'member')
        {
            $lang_rules=[
                
               'type_id'=>'required',
               'relative'=>'required',
               'age'=>'required',
               

            ];
            $rules= array_merge($rules, $lang_rules);
        }
        else{
            $lang_rules=[
               'country_id'=>'required',
               'category_id'=>'required',
               'gender'=>'required',
               'experience.*.name_ar'=> 'required',
               
            'certification.*.name_ar'=> 'required',

            ];
            if ( !$this->member  ) {
            $lang_rules['experience.*.image'] ='required';
            $lang_rules['certification.*.image'] = 'required';
        } else {
            
            $lang_rules['experience.*.image'] ='sometimes';
            $lang_rules['certification.*.image'] = 'sometimes';
        }
        
            $rules= array_merge($rules, $lang_rules);
        }

        

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('members');
        $local = getCurrentLocale();
        $attributes= [
            'name'=> $field->{$local}->name ?? __('members.name'),
            'phone'=> $field->{$local}->phone ?? __('members.phone'),
            'email'=> $field->{$local}->email ?? __('members.email'),
            'photo'=> $field->{$local}->photo ?? __('members.photo'),
            'password'=> $field->{$local}->password ?? __('members.password'),
            'password_confirmation'=> $field->{$local}->password_confirmation ?? __('members.password_confirmation'),
            'modules'=> $field->{$local}->modules ?? __('members.modules'),
        ];
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
